	.file	"P.c"
	.version	"01.01"
gcc2_compiled.:
	.ident	"@(#)head:stdio.h	2.34.1.2"
	.ident	"@(#)head:math.h	2.11.6.1"
.section	.rodata
	.align 4
.LC0:
	.long	0x11111291
	.long	0x3f711111
	.align 4
.text
	.align 16
.globl P
	.type	 P,@function
P:
	fld1			/ make pi/2 
	fchs
	pushl %eax
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushl %ebp
	movl %esp,%ebp
	fldpi			/ make pi/2 ...
	fscale
	subl $80,%esp
	movl 28(%ebp),%edx
	movl 24(%ebp),%ecx
	fstp %st(1)
	fstpl -8(%ebp)		/ save pi/2


	fldl (%edx) 		/ initialize the differences
	fldl 16(%edx)
	fldl 16(%ecx)		/ 64 - 67:
	fld %st(2)
	fsubr %st(1),%st
	fstpl -32(%ebp)		/ nx[1]
	fsub %st(1),%st
	fstpl -40(%ebp)		/ nx[0]
	fldl (%ecx)
	fld %st(2)
	fsubr %st(1),%st
	fstpl -16(%ebp)		/ nx[3]
	fsubp %st,%st(1)
	fstpl -24(%ebp)		/ nx[2]
	fstp %st(0)

	fldl 8(%edx)		/ 69 - 72:
	fldl 24(%edx)
	fldl 24(%ecx)
	fld %st(2)
	fsubr %st(1),%st
	fstpl -64(%ebp)		/ ex[1]
	fsub %st(1),%st
	fstpl -72(%ebp)		/ ex[0]
	fldl 8(%ecx)
	fld %st(2)
	fsubr %st(1),%st
	fstpl -48(%ebp)		/ ex[3]
	fsubp %st,%st(1)
	fstpl -56(%ebp)		/ ex[2]
	fstp %st(0)

	fldz			/ 74: init a
	movw $0x6996,%bx	/ 22 - 26: init sign[4][4] (1 word)
	movl $3,%ecx		/ 76: for(i = 0; i < 4; i++)
.FOR_I:
	movl $3,%edx		/ 77: for(j = 0; j < 4; j++)

.FOR_J:
	movl -36(%ebp,%ecx,8),%eax 	/ 79: n = nx[i];  actually ny[j]
	pushl %eax
	movl -40(%ebp,%ecx,8),%eax
	pushl %eax


	movl -68(%ebp,%edx,8),%eax	/ 80: e = ey[j];  actually ey[i]
	pushl %eax
	movl -72(%ebp,%edx,8),%eax
	pushl %eax

	fstpl -80(%ebp)			/ save a, in case of fpu stack overflow


.F__:
	movw 6(%esp),%ax		/ 84: if(fabs(e) <= SMALL)
	andw $0x7FF0,%ax 		/ get exp(e) abs of exp only
	cmpw $0x3CD0,%ax		/  (small is 2^50)
	jge .E_BIG	
	movw 14(%esp),%ax		/ 85: if(fabs(n) <= SMALL)
	andw $0x7FF0,%ax
	cmpw $0x3CD0,%ax		/  (small is 2^50)
	jge .N_LOG
	fldz				/ 86: f = 0.0;
	jmp .DON
	.align 16

.N_LOG:
	fldl 8(%esp)			/ 88: f = log(n2)*n2*n2;
.S_LOG:
	fld %st(0)			/ n
	fmulp %st,%st(1)		/ n^2
	fld %st(0)	
	fmul %st,%st(1)			/ n^4
	fyl2x				/ n^4 log2(n^2)
	fldln2
	fmulp %st,%st(1)		/ n^4 ln(n^2)
	jmp .DON
	.align 16

.E_BIG:
	movw 14(%esp),%ax		/ 89: else if(fabs(n) <= SMALL)
	andw $0x7FF0,%ax
	cmpw $0x3CD0,%ax
	jge .FULL
	fldl (%esp)			/ 90: f = log(e2)*e2*e2;
	jmp .S_LOG
	.align 16

.FULL:
	fldl -8(%ebp)			/ 93 - 99
	movb 15(%esp),%al		/ get sign(n)
	andb $0x7F,15(%esp)		/ make n > 0
	movb 7(%esp),%ah		/ get sign(e)
	andw $0x8080,%ax		/ isolate the signs
	xorb %ah,%al			/ check if they are the same
	jz .SAME_S
	fchs				/ if diff, use -pi/2
	orb $0x80,7(%esp)		/ and make e < 0
	jmp .DO_IT
	.align 16

.SAME_S:
	andb $0x7F,7(%esp)		/ else use pi/2 and make e > 0
.DO_IT:
	fldl (%esp)		/ you figure it out.  it does:
	fst %st(2)		/ ln(e^2 + n^2)(e^4 - 6 e^2*n^2 + n^4) + 25 e^2 * n^2
	fldl 8(%esp)		/ -8 e*n*(e^2*(+/-pi/2 - atan(e/n) - n^2*atan(e/n))
	fst %st(4)
	fpatan		
	fsubr %st,%st(1)
	fld %st(3)
	fmul %st,%st(0)
	fmul %st,%st(1)
	fstp %st(5)
	fld %st(2)
	fmul %st,%st(0)
	movl $-6,(%esp)	
	fmul %st,%st(2)
	fstp %st(6)
	faddp %st,%st(1)	/ (e^2*(+/-pi/2 - atan(e/n) - n^2*atan(e/n))
	fstp %st(5)
	fmulp %st,%st(1)
	fmul %st,%st(3)		/ e*n*(e^2*(+/-pi/2 - atan(e/n) - n^2*atan(e/n))
	fmul %st,%st(0)	
	fst %st(4)
	fimull (%esp)	
	movl $-8,(%esp)	
	fld %st(1)
	fmul %st,%st(0)
	faddp %st,%st(1)
	fld %st(2)
	fmul %st,%st(0)
	faddp %st,%st(1)	/ (e^4 - 6 e^2 n^2 + n^4)
	fxch %st(2)
	faddp %st,%st(1)
	fyl2x
	fldln2
	fmulp %st,%st(1)	/ (e^4 - 6 e^2 n^2 + n^4) ln(e^2 + n^2)
	fxch %st(1)		/ -8 e*n*(e^2*(+/-pi/2 - atan(e/n) - n^2*atan(e/n))
	fimull (%esp)
	faddp %st,%st(1)
	movl $25,(%esp)	
	fxch %st(1)
	fimull (%esp)		/ 25 e^2 n^2
	faddp %st,%st(1)	/  the whole thing as mentioned above
.DON:
	addl $16,%esp		/ fix up stack
	fldl -80(%ebp)		/ get sum
	rcrw %bx		/ check the sign matrix
	jc .NEG_SIGN
	faddp %st,%st(1)	/ if pos, add
	jmp .LP_END
	.align 16

.NEG_SIGN:
	fsubp %st,%st(1)	/ else sub
.LP_END:
	decl %edx		/ end of for j loop
	jns .FOR_J
	decl %ecx
	jns .FOR_I		/ end of for i loop


	fmull .LC0		/ sum * K (Uo/96PI)
	movl 28(%ebp),%edx	/ * ep->area_r
	movl 24(%ebp),%ecx	/ * ef->area_r
	fmull 32(%edx)
	fmull 32(%ecx)		/ leave answer on fpu stack (P returns double)

.END_NOW:

	movl %ebp,%esp
	popl %ebp
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax
	ret

.Lfe1:
	.size	 P,.Lfe1-P
	.comm	input_cond,4,4
	.comm	cond_head,4,4
	.comm	q_matrix,4,4
	.comm	s_matrix,4,4
	.comm	fp,4,4
	.ident	"GCC: (GNU) 2.3.1"
